<?php
/**
F Yazılım 2009 - 2017
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

class fcurrency extends Module
{
    protected $config_form = false;

    public function __construct()
    {
        $this->name = 'fcurrency';
        $this->tab = 'administration';
        $this->version = '1.0.0';
        $this->author = 'fyazilim';
        $this->module_key = 'b13e0ca14c55a0671b84c086f1010ac5';
        $this->need_instance = 0;
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('F Currency');
        $this->description = $this->l('Add Multy Currency Price');

        $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
    }

    public function install()
    {
        include(dirname(__FILE__).'/sql/install.php');
		return parent::install() &&
            $this->registerHook('header') &&
            $this->registerHook('backOfficeHeader') &&
			$this->registerHook('displayAdminProductsExtra');
    }

    public function uninstall()
    {
        include(dirname(__FILE__).'/sql/uninstall.php');
		return parent::uninstall();
    }

    /**
     * Load the configuration form
     */
    public function getContent()
    {
		$output = null;
		if (((bool)Tools::isSubmit('deleteCurrency')) == true) {
			$currency 	= Tools::getValue('deleteCurrency');
			
			if (Validate::isInt($currency))
			{
				Db::getInstance()->execute('DELETE FROM '._DB_PREFIX_.'fcurrency WHERE id_currency = '.(int)$currency.' LIMIT 1');
				$output .= $this->displayConfirmation($this->l('Deleted Currency'));
			}
		}
		if (((bool)Tools::isSubmit('addCurrency')) == true) {
			$currency 	= Tools::getValue('currency'); 
			$sign 		= Tools::getValue('sign');
			$say 		= Tools::strlen($sign);
			
			if (Validate::isCarrierName($currency) AND $say < 4)
			{
				Db::getInstance()->insert('fcurrency', array(
					'name'  => pSQL($currency),
					'icon'  => pSQL($sign),
				)); 
				$output .= $this->displayConfirmation($this->l('Add new currency'));
			}
		}
		$currencys	= Db::getInstance()->executeS('SELECT * FROM `'._DB_PREFIX_.'fcurrency`');
		$this->context->smarty->assign(array(
			'currencys' => $currencys,
			'cron' 		=> _PS_BASE_URL_._MODULE_DIR_.'fcurrency/cron.php?token='.Tools::substr(Tools::encrypt('fcurrency/cron'), 0, 10).'&id_shop='.$this->context->shop->id,
		));

        return $output.$this->context->smarty->fetch($this->local_path.'views/templates/admin/configure.tpl');
    }
    public function hookBackOfficeHeader()
    {
		if (Tools::getValue('controller') == 'AdminProducts') {
            $this->context->controller->addCSS($this->_path.'views/css/extra.css');
        }
    }

    public function hookDisplayAdminProductsExtra()
	{
		$output 	= null;
		$idpr		= Tools::getValue('id_product');
		
		
		if (((bool)Tools::isSubmit('addPrice')) == true) {
			$fpice 		= Tools::getValue('fprice'); 
			$currency 	= Tools::getValue('currency');
			
			if (Validate::isPrice($fpice) AND Validate::isInt($currency) AND Validate::isInt($idpr))
			{
				$isHave = Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'fcurrency_product` WHERE `id_product` = '.(int)$idpr.'');
				
				if ($isHave)
				{
					Db::getInstance()->update('fcurrency_product', array(
						'price'     	=> (float)$fpice,
						'id_currency'  	=> (int)$currency,
					), 'id_product  = '.(int)$idpr.'');
				}
				else
				{
					Db::getInstance()->insert('fcurrency_product', array(
						'price'      	=> (float)$fpice,
						'id_currency'  	=> (int)$currency,
						'id_product' 	=> (int)$idpr
					)); 
				}
				$output .= $this->displayConfirmation($this->l('Product price saved'));
			}
		}
		
		$product	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'product` WHERE `id_product` = '.(int)$idpr.'');
		$fproduct	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'fcurrency_product` fp INNER JOIN `'._DB_PREFIX_.'fcurrency` fc ON fp.id_currency = fc.id_currency  WHERE `id_product` = '.(int)$idpr.'');
		$doviz 		= simplexml_load_file('http://www.tcmb.gov.tr/kurlar/today.xml');
		if ($fproduct['icon'] == '$')
			$kur 		= $doviz->Currency[0]->BanknoteSelling;
		else if ($fproduct['icon'] == '€')
			$kur		= $doviz->Currency[3]->BanknoteSelling;
		
		$newprice 	= $kur*$fproduct['price'];
		Db::getInstance()->execute('UPDATE '._DB_PREFIX_.'product SET `price` = '.pSQL($newprice).' WHERE id_product = '.(int)$idpr.'');
		Db::getInstance()->execute('UPDATE '._DB_PREFIX_.'product_shop SET `price` = '.pSQL($newprice).' WHERE id_product = '.(int)$idpr.'');
		$product	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'product` WHERE `id_product` = '.(int)$idpr.'');
		$currencys	= Db::getInstance()->executeS('SELECT * FROM `'._DB_PREFIX_.'fcurrency`');
		
		
		$this->context->smarty->assign(array(
			'kur'  		=> $kur,
			'price'  	=> $product['price'],
			'fprice'  	=> $fproduct['price'],
			'ficon'  	=> $fproduct['icon'],
			'fcurrency'	=> $fproduct['id_currency'],
			'newprice'  => $newprice,
			'currencys' => $currencys,
		));
		
        return $output.$this->context->smarty->fetch($this->local_path.'views/templates/admin/product.tpl');
	}
	public static function kurGetir($name)
	{
		if (Validate::isCarrierName($name))
		{
			$doviz 		= simplexml_load_file('http://www.tcmb.gov.tr/kurlar/today.xml');
			if ($name == 'Dolar')
				$kur 		= $doviz->Currency[0]->BanknoteSelling;
			else if ($name == 'Euro')
				$kur		= $doviz->Currency[3]->BanknoteSelling;
			
			return $kur;
		}
	}
}
