<?php
/**
F Yazılım 2009 - 2017
*/

if (!defined('_PS_VERSION_')) {
    exit;
}

class fcurrency extends Module
{
    protected $config_form = false;

    public function __construct()
    {
        $this->name = 'fcurrency';
        $this->tab = 'administration';
        $this->version = '1.0.0';
        $this->author = 'fyazilim';
        $this->module_key = 'b13e0ca14c55a0671b84c086f1010ac5';
        $this->need_instance = 0;
        $this->bootstrap = true;

        parent::__construct();

        $this->displayName = $this->l('F Currency');
        $this->description = $this->l('Add Multy Currency Price');

        $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
    }

    public function install()
    {
        include(dirname(__FILE__).'/sql/install.php');
		return parent::install() &&
            $this->registerHook('header') &&
			$this->registerHook('actionProductUpdate') &&
            $this->registerHook('backOfficeHeader') &&
			$this->registerHook('displayAdminProductsExtra');
    }

    public function uninstall()
    {
        include(dirname(__FILE__).'/sql/uninstall.php');
		return parent::uninstall();
    }

    /**
     * Load the configuration form
     */
    public function getContent()
    {
		$output = null;
		if (((bool)Tools::isSubmit('deleteCurrency')) == true) {
			$currency 	= Tools::getValue('deleteCurrency');
			
			if (Validate::isInt($currency))
			{
				Db::getInstance()->execute('DELETE FROM '._DB_PREFIX_.'fcurrency WHERE id_currency = '.(int)$currency.' LIMIT 1');
				$output .= $this->displayConfirmation($this->l('Deleted Currency'));
			}
		}
		if (((bool)Tools::isSubmit('addCurrency')) == true) {
			$currency 	= Tools::getValue('currency'); 
			$sign 		= Tools::getValue('sign');
			$say 		= Tools::strlen($sign);
			
			if (Validate::isCarrierName($currency) AND $say < 4)
			{
				Db::getInstance()->insert('fcurrency', array(
					'name'  => pSQL($currency),
					'icon'  => pSQL($sign),
				)); 
				$output .= $this->displayConfirmation($this->l('Add new currency'));
			}
		}
		$currencys	= Db::getInstance()->executeS('SELECT * FROM `'._DB_PREFIX_.'fcurrency`');
		$this->context->smarty->assign(array(
			'currencys' => $currencys,
			'cron' 		=> _PS_BASE_URL_._MODULE_DIR_.'fcurrency/cron.php?token='.Tools::substr(Tools::encrypt('fcurrency/cron'), 0, 10).'&id_shop='.$this->context->shop->id,
		));

        return $output.$this->context->smarty->fetch($this->local_path.'views/templates/admin/configure.tpl');
    }
    public function hookActionProductUpdate($params)
    {
		$idpr		= $params['id_product'];
		$fpice 		= Tools::getValue('fprice'); 
		$currency 	= Tools::getValue('currency');
		$isHave = Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'fcurrency_product` WHERE `id_product` = '.(int)$idpr.'');

		if ($isHave)
		{
			Db::getInstance()->update('fcurrency_product', array(
				'price'     	=> (float)$fpice,
				'id_currency'  	=> (int)$currency,
			), 'id_product  = '.(int)$idpr.'');
		}
		else
		{
			Db::getInstance()->insert('fcurrency_product', array(
				'price'      	=> (float)$fpice,
				'id_currency'  	=> (int)$currency,
				'id_product' 	=> (int)$idpr
			)); 
		}

		$fproduct	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'fcurrency_product` fp INNER JOIN `'._DB_PREFIX_.'fcurrency` fc ON fp.id_currency = fc.id_currency  WHERE `id_product` = '.(int)$idpr.'');
		$kur = fcurrency::kurGetir($fproduct['name']);
		
		$yfiyat = (float)$fproduct['price'];
		
		$newprice 	= $kur*$yfiyat;
		if ($newprice > 0)
		{
		    Db::getInstance()->execute('UPDATE '._DB_PREFIX_.'product SET `price` = '.pSQL($newprice).' WHERE id_product = '.(int)$idpr.'');
		    Db::getInstance()->execute('UPDATE '._DB_PREFIX_.'product_shop SET `price` = '.pSQL($newprice).' WHERE id_product = '.(int)$idpr.'');
		}
		
    }	
	public function hookDisplayHeader()    
	{		
		if (Tools::getValue('controller') == 'product') {
            $id_product = Tools::getValue('id_product');
			$fproduct	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'fcurrency_product` fp INNER JOIN `'._DB_PREFIX_.'fcurrency` fc ON fp.id_currency = fc.id_currency  WHERE `id_product` = '.(int)$id_product.'');
			if ($fproduct)				
				$have = 1;			
			else				
				$have = 0;			
			$this->context->smarty->assign(array(
			'fiyat'  	=> $fproduct['price'],
			'icon'  	=> $fproduct['icon'],
			'have'  	=> $have,
			));
			}
	}

    public function hookDisplayAdminProductsExtra($params)
	{
		$idpr		= $params['id_product'];
		
		$product	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'product` WHERE `id_product` = '.(int)$idpr.'');
		$fproduct	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'fcurrency_product` fp INNER JOIN `'._DB_PREFIX_.'fcurrency` fc ON fp.id_currency = fc.id_currency  WHERE `id_product` = '.(int)$idpr.'');
		
		$kur = fcurrency::kurGetir($fproduct['name']);
		
		$product	= Db::getInstance()->getRow('SELECT * FROM `'._DB_PREFIX_.'product` WHERE `id_product` = '.(int)$idpr.'');
		$currencys	= Db::getInstance()->executeS('SELECT * FROM `'._DB_PREFIX_.'fcurrency`');
		$yfiyat 	= (float)$fproduct['price'];
		$newprice 	= $kur*$fiyat;
		
		
		
		$this->context->smarty->assign(array(
			'fprice'  	=> $fproduct['price'],
			'currencys' => $currencys,
		));
		
        return $this->context->smarty->fetch($this->local_path.'views/templates/admin/product.tpl');
	}
	public static function kurGetir($name)
	{
		if (Validate::isCarrierName($name))
		{
			if ($name == 'Dolar')
				$deger = 'USDTRY';
			else if ($name == 'Euro')
				$deger = 'EURTRY';
			else if ($name == 'Altın')
				$deger = 'GLDGR';
		
			$url = 'http://api.bigpara.hurriyet.com.tr/doviz/headerlist/anasayfa';
			$cekVeri = file_get_contents($url);
			$gelenVeri = json_decode($cekVeri);
			foreach($gelenVeri->data as $veri)
			{
				 if($veri->SEMBOL == $deger)
				 {
					  $kur = $veri->ALIS;
				 }
			}
			
			return $kur;
		}
	}
}
